// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#include <iostream>
#include <algorithm>
#include <string>
#include "QVector.h"
#include "QMatrix.h"
#include "Partition.h"
#include "LP.h"

using namespace std;

int  main(int argc, char **argv){

  int dim,n_points;

  cin >> dim;
  cin >> n_points;
  
  


  QMatrix V(n_points,dim);

  cin >> V;

  cerr << "V: " << endl << V;
  int h_rows;

  cin >> h_rows;
  

  QMatrix H(h_rows,dim);
  
  cin >> H;

  cerr << "H: " << endl << H;

  Partition sigma(n_points);
  sigma.first();
  

  QVector e(dim,1);
  
  


  QMatrix Ieq=Rational(-1)*H.transpose();

  QVector zh(h_rows,0);
  for (int i=0; i<n_points; i++){
    Ieq.append(zh);
  }
  
  Ieq.append(QVector(h_rows,1));
  Ieq.append(zh);

  Ieq=Ieq.transpose();

  QMatrix NonNeg(n_points,dim+n_points+2);
  
  for(int j=0; j<n_points; j++){
    NonNeg[j][dim+j]=1;
  }

  Ieq.append(NonNeg);

  cout << "Ieq: "<< endl << Ieq << endl;

  QVector zd(dim,0);  
  QVector obj(dim+n_points+2);

  obj[dim+n_points]=1;

  LP L;

  L.set_ieq(Ieq);
  L.set_obj(obj);

  do {
    QMatrix W=QMatrix::Identity(dim);
    
    primary_iterator i;
    complement_iterator j;

    int mink_size=0;
    for ( i=sigma.begin(); i!=sigma.end(); i++){
      for ( j=sigma.cbegin(); j!=sigma.cend(); j++){
	mink_size++;
	cerr << *i <<":" << *j  << endl;
	W.append(V[*i]-V[*j]);
      }
    }
    W.append(zd);
    W.append(zd);

    QMatrix E=W.transpose();
  
    QVector ze(dim,0);
    ze.append(QVector(mink_size,1));
    ze.append(0);
    ze.append(-1);
  
    
    E.append(ze);

    cout << E << endl;
    L.set_eq(E);
    L.solve();

  } while (sigma.next());
}

