// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#ifndef DB_VECTOR_H
#define DB_VECTOR_H
#include "rational.h"
#include "debug.h"


class vector {
 private:

  int size;
  rational   *data;
  
 public:
  
  int  dim() const { return size; }
  vector(int s=1){ 
    data= new rational [s];
    size=s;
  };

  rational& operator []   (int j) const { 
    check(j>=0 && j<size,check_bounds); return data[j]; };
  
  vector& operator | (vector &brother) {this->append(brother);};
  vector& append(vector &brother);


};

inline ostream& operator<< (ostream& os, const vector& v) {
  for (int j=0 ; j< v.dim(); j++){
    if (j){
      os << " ";
    }
    os << v[j];
  }
  os << "\n";
  return os;
};

#endif
